Bug 1017875 - (CVE-2013-4416) CVE-2013-4416 xen: ocaml xenstored mishandles oversized message replies (XSA-72)
CVE-2013-4416 xen: ocaml xenstored mishandles oversized message replies (XSA-72)
Status: NEW
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
medium Severity medium
: ---
: ---
Assigned To: Red Hat Product Security
impact=moderate,public=20131029,repor...
: Security
Depends On: 1024450
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-10 12:28 EDT by Vincent Danen
Modified: 2013-11-10 21:34 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
upstream patch (2.57 KB, patch)
2013-10-10 12:34 EDT, Vincent Danen
no flags Details | Diff

  None (edit)
Description Vincent Danen 2013-10-10 12:28:53 EDT
The Ocaml xenstored implementation ("oxenstored") cannot correctly handle
a message reply larger than XENSTORE_PAYLOAD_SIZE when communicating
with a client domain via the shared ring mechanism.

When this situation occurs the connection to the client domain will be
shutdown and cannot be restarted leading to a denial of service to
that domain.

Clients in the same domain as xenstored which are using the Unix
domain socket mechanism are not vulnerable.

A malicious domain can create a directory containing a large number of
entries in the hopes that a victim domain will attempt to list the
contents of that directory. If this happens then the victim domain's
xenstore connection will be shutdown leading to a denial of service
against that domain.

If the victim domain is a toolstack or control domain then this can
lead to a denial of service against the whole system.

All systems using oxenstored are potentially vulnerable.

oxenstored was added in Xen 4.1.0. From Xen 4.2.0 onward it is used by
default if an ocaml toolstack was present at build time.

In its default configuration the C xenstored implementation is not
vulnerable. By default this implementation imposes a quota on the
maximum directory size which is less than XENSTORE_PAYLOAD_SIZE. If
you have adjusted the quota using the --entry-size / -S option to a
value larger than XENSTORE_PAYLOAD_SIZE (4096 bytes) then you may be
vulnerable.

Systems where the toolstack and oxenstored live in the same domain
will default to using Unix domain socket based communications and
therefore are not vulnerable to the host wide denial of service by
default. In such a configuration guest domains which do not list
xenstore paths belonging to untrusted foreign domains will not be
vulnerable to the DoS. (In the common case guests will not have
permission to do so in any case.)

Switching to the C xenstored (in its default configuration), will
eliminate this vulnerability.


Acknowledgements:

Red Hat would like to thank the Xen project for reporting this issue. Upstream acknowledges Thomas Sanders of Citrix as the original reporter.
Comment 1 Vincent Danen 2013-10-10 12:29:56 EDT
Statement:

Not vulnerable.

This issue does not affect the versions of the xen package as shipped with Red Hat Enterprise Linux 5 as it does not provide oxenstored.

This issue does not affect Red Hat Enterprise Linux 6 and Red Hat Enterprise MRG 2.
Comment 2 Vincent Danen 2013-10-10 12:34:00 EDT
Created attachment 810643 [details]
upstream patch
Comment 3 Vincent Danen 2013-10-29 12:41:39 EDT
External References:

http://xenbits.xen.org/xsa/advisory-72.html
Comment 4 Vincent Danen 2013-10-29 12:42:52 EDT
Created xen tracking bugs for this issue:

Affects: fedora-all [bug 1024450]
Comment 5 Fedora Update System 2013-11-10 01:26:54 EST
xen-4.3.1-1.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 6 Fedora Update System 2013-11-10 21:30:44 EST
xen-4.2.3-7.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 7 Fedora Update System 2013-11-10 21:34:46 EST
xen-4.2.3-7.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.